"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = ContentPlugin;

var _loadFile = require("./loadFile");

var _loadDirectory = require("./loadDirectory");

const UnsupportedError = new Error('Unsupported configuration for babel-plugin-content-transformer');

function ContentPlugin({
  types
}) {
  return {
    visitor: {
      ImportDeclaration(p, state) {
        const opts = state.opts;

        if (opts.transformers) {
          for (const t of opts.transformers) {
            if (!t.file) {
              throw UnsupportedError;
            }

            if (p.node && p.node.source && t.file.test(p.node.source.value)) {
              (0, _loadFile.loadFile)(types, p, state, t);
              break;
            }
          }
        }

        if (opts.content) {
          for (const c of opts.content) {
            if (!c.dir) {
              throw UnsupportedError;
            }

            if (p.node && p.node.source && c.dir.test(p.node.source.value)) {
              (0, _loadDirectory.loadDirectory)(types, p, state, c);
              break;
            }
          }
        }

        if (!(opts.transformers || opts.content)) {
          throw UnsupportedError;
        }
      }

    }
  };
}